#!/usr/bin/perl

#create a 2,2,1 network.
# input nodes named A & B, output node named RESULT
print `nunu -f A,B -l RESULT -m 2 > and.net`;

#uncomment the next line to see the network description...
# don't uncomment if you are using gnuplot (see below)
#print `cat and.net`;

use POSIX;

# gee, can i learn AND in 4000 iterations?
$iterations=4000;

foreach my $i (1...$iterations)
  {
    my $dothis = floor((rand()/1)*4); 
   if ($dothis==0)
     {    print $i, `echo \'A 1\nB 0\n\' | nunu -n and.net`; }
    elsif ($dothis==1)
      {    print $i,`echo \'A 0\nB 0\n\' | nunu -n and.net`; }
    elsif ($dothis==2)
      {   print $i,`echo \'A 0\nB 1\n\' | nunu -n and.net`; }
    else
      {  
	# the only case in which we are looking for a RESULT of 1
	# all the other cases above omit -t RESULT which means
	# we are looking for a zero for output node
	print $i, `echo \'A 1\nB 1\n\' | nunu -n and.net -t RESULT`; 
      }
  }

# uncomment then next line if you have gnuplot installed.
# if you say "and.pl > and.dat &&  chmod a+x plot-and && plot-and"
# you'll get a nice graph showing nunu's learning rate! 
#`echo \"plot [1:$iterations] \'and.dat\'\npause 30" > plot-and`;

